// CDScores.cpp : implementation file
//

#include "stdafx.h"
#include "CDScores.h"
#include "..\updownclient.h"
#include "..\emule.h"


// CCDScores dialog

IMPLEMENT_DYNCREATE(CCDScores, CPropertyPage)

CCDScores::CCDScores() : CPropertyPage(CCDScores::IDD)
{
	//{{AFX_DATA_INIT(CCDScores)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CCDScores::~CCDScores()
{
}

void CCDScores::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDScores)
	DDX_Control(pDX, IDC_SCORES_LBL, m_ctrlScores);
	DDX_Control(pDX, IDC_REMOTESCORES_LBL, m_ctrlRemoteScores);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_DLUPMODIFIER_VAL, m_ctrlDlUpModifier);
	DDX_Control(pDX, IDC_COMMUNITYUSER_VAL, m_ctrlCommunityUser);
	DDX_Control(pDX, IDC_RATING_VAL, m_ctrlRating);
	DDX_Control(pDX, IDC_UPQUEUESCORE_VAL, m_ctrlUpQueueScore);
	DDX_Control(pDX, IDC_QUEUETIME_VAL, m_ctrlQueueTime);
	DDX_Control(pDX, IDC_REMDLUPMODIFIER_VAL, m_ctrlRemDlUpModifier);
	DDX_Control(pDX, IDC_REMRATING_VAL, m_ctrlRemRating);
}


BEGIN_MESSAGE_MAP(CCDScores, CPropertyPage)
	//{{AFX_MSG_MAP(CCDScores)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CCDScores message handlers

BOOL CCDScores::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCDScores::Update(void)
{
	EMULE_TRY

	if ((m_pClient == NULL) || !::IsWindow(GetSafeHwnd()))
		return;

	CString		strCommunityUser = GetResString(IDS_DISABLED);

	if (g_eMuleApp.m_pGlobPrefs->CommunityEnabled())
		strCommunityUser = YesNoStr(m_pClient->IsCommunity());
	m_ctrlCommunityUser.SetWindowText(strCommunityUser);

	CString		strBuffer;

	if (m_pClient->Credits())
	{
		strBuffer.Format(_T("%.1f"), (double)m_pClient->Credits()->GetScoreRatio(m_pClient->GetIP()));
		m_ctrlDlUpModifier.SetWindowText(strBuffer);

		strBuffer.Format(_T("%.1f"), m_pClient->GetRemoteBaseModifier());
		m_ctrlRemDlUpModifier.SetWindowText(strBuffer);

		strBuffer.Format(_T("%u"), m_pClient->GetRemoteRatio());
		m_ctrlRemRating.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlDlUpModifier.SetWindowText(_T("?"));
		m_ctrlRemDlUpModifier.SetWindowText(_T("?"));
		m_ctrlRemRating.SetWindowText(_T("?"));
	}

	bool	bLoadedSourceName = false;

	if (m_pClient->GetUserName())
	{
		bLoadedSourceName = (_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_LOADEDSOURCE)) != NULL) || 
							(_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_EXCHANGEDSOURCE)) != NULL) ;
	}

	if (m_pClient->GetUserName() && !bLoadedSourceName)
	{
		if (m_pClient->IsDownloading())
			strBuffer = _T("-");
		else
			strBuffer.Format(_T("%u"), m_pClient->GetScore(m_pClient->IsDownloading(), true));
		m_ctrlRating.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlRating.SetWindowText(_T("?"));
	}

	if (m_pClient->GetUploadState() != US_NONE && !m_pClient->IsDownloading())
	{
		strBuffer.Format(_T("%u"), m_pClient->GetScore(m_pClient->IsDownloading(), false));
		m_ctrlUpQueueScore.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlUpQueueScore.SetWindowText(_T("-"));
	}

	if (m_pClient->GetDownloadState() == DS_ONQUEUE)
		m_ctrlQueueTime.SetWindowText(::CastSecondsToHM(m_pClient->GetDLQueueWaitTime() / 1000));
	else
		m_ctrlQueueTime.SetWindowText(_T("-"));

	EMULE_CATCH
}

void CCDScores::Localize(void)
{
	static const uint16 s_auResTbl[][2] =
	{
		{ IDC_SCORES_LBL, IDS_CD_SCORES },
		{ IDC_COMMUNITYUSER_LBL, IDS_COMUSER },
		{ IDC_DLUPMODIFIER_LBL, IDS_CD_MOD },
		{ IDC_UPQUEUESCORE_LBL, IDS_CD_USCORE },
		{ IDC_QUEUETIME_LBL, IDS_QUEUETIMELBL },
		{ IDC_REMOTESCORES_LBL, IDS_INFLST_REMOTE_SCORES },
		{ IDC_REMDLUPMODIFIER_LBL, IDS_CD_MOD },
	};
	static const uint16 s_auResTbl2[][2] =
	{
		{ IDC_RATING_LBL, IDS_QL_RATING },
		{ IDC_REMRATING_LBL, IDS_QL_RATING }
	};

	if (GetSafeHwnd())
	{
		CString strBuffer;

		for (uint32 i = 0; i < ELEMENT_COUNT(s_auResTbl); i++)
		{
			GetResString(&strBuffer, static_cast<UINT>(s_auResTbl[i][1]));
			SetDlgItemText(s_auResTbl[i][0], strBuffer);
		}

		for (uint32 i = 0; i < ELEMENT_COUNT(s_auResTbl2); i++)
		{
			GetResString(&strBuffer, static_cast<UINT>(s_auResTbl2[i][1]));
			strBuffer += _T(":");
			SetDlgItemText(s_auResTbl2[i][0], strBuffer);
		}
	}
}
