// EmClient.cpp
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OpCode.h"
#include "TaskProcessorSockets.h"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CEmClient::~CEmClient()
{
	if (closesocket(m_hSocket))
		AddDebugLogLine("closesocket failed");
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Peer::GetType() const
{
	return T_CLIENT_PEER;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Server::GetType() const
{
	return T_CLIENT_SERVER;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Web::GetType() const
{
	return T_CLIENT_WEB;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
T_CLIENT_TYPE CEmClient_Xml::GetType() const
{
	return T_CLIENT_XML;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmClient::OnConnected()
{
	if (m_pOnCompletionTask != NULL)
	{
		m_pOnCompletionTask->m_iMessage = FD_CONNECT;
		g_stEngine.Sockets.Push(m_pOnCompletionTask);
		m_pOnCompletionTask = NULL;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmClient::OnAccepted()
{
	if (m_pOnCompletionTask != NULL)
	{
		m_pOnCompletionTask->m_iMessage = FD_ACCEPT;
		g_stEngine.Sockets.Push(m_pOnCompletionTask);
		m_pOnCompletionTask = NULL;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CEmClient::OnDisconnected()
{
	if (m_pOnCompletionTask != NULL)
	{
		m_pOnCompletionTask->m_iMessage = FD_CLOSE;
		g_stEngine.Sockets.Push(m_pOnCompletionTask);
		m_pOnCompletionTask = NULL;
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// in the future - move webserver to this engine
//void CEmClient_Web::OnConnected()
//{
//	// say something...
//	char szSend[] = "GET / HTTP 1.1\r\n\r\n";
//	stEngine.m_stTcp.AllocSend(m_hSocket, szSend, sizeof(szSend) - 1);
//}
