#pragma once

struct OFFEREDFILE
{
	BYTE	_Hash[16];
	ULONG	_ClientID;
	USHORT	_ClientPort;
	CString	_FileName;
	DWORD	_FileSize;
	CString	_FileType;

	OFFEREDFILE& operator = (const OFFEREDFILE& stObj);
};

//////////////////////////////////////////////////////////////////////
struct CTask_LoginToServer : public CTcpCompletionTask
{
	CTask_LoginToServer()
		: m_pServer(NULL) {}

	virtual void			SetClient(CEmClient *pClient) { m_pServer = dynamic_cast<CEmClient_Server*>(pClient); }
	virtual bool			Process();
	virtual LPCTSTR TaskName(){ return _T("LoginToServer"); }

	CEmClient_Server		*m_pServer;
};
//////////////////////////////////////////////////////////////////////
struct CTask_DisconnectServer : public CTcpCompletionTask
{
	CTask_DisconnectServer()
		: m_pServer(NULL) {}

	virtual void			SetClient(CEmClient *pClient) { m_pServer = dynamic_cast<CEmClient_Server*>(pClient); }
	virtual bool			Process();
	virtual LPCTSTR TaskName(){ return _T("DisconnectServer"); }

	CEmClient_Server		*m_pServer;
};
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
struct CTask_SayHelloToPeer : public CTcpCompletionTask
{
	CTask_SayHelloToPeer()
		: m_pPeer(NULL) {}

	virtual void	SetClient(CEmClient *pClient) { m_pPeer = dynamic_cast<CEmClient_Peer*>(pClient); }
	virtual bool	Process();
	virtual LPCTSTR TaskName(){ return _T("SayHelloToPeer"); }

	CEmClient_Peer	*m_pPeer;
};
//////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////
// Send list of shared files
struct CTask_SendSharedList : public CTask {
	CTask_SendSharedList();
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("SendSharedList"); }

	int	m_nState;
	CArray<OFFEREDFILE, OFFEREDFILE&> m_Files;
};

//////////////////////////////////////////////////////////////////////
// Send requested filename
struct CTask_SendRequestedFileName : public CTask {
	CTask_SendRequestedFileName(BYTE Hash[16], CEmClient* pClient);
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("SendRequestedFileName"); }

	int			m_nState;
	BYTE		m_Hash[16];
	CString		m_strFileName;
	CEmClient*	m_pClient;
};

//////////////////////////////////////////////////////////////////////
// Send upload request answer
struct CTask_UploadReqResult : public CTask {
	CTask_UploadReqResult(BYTE Hash[16], CEmClient* pClient);
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("UploadReqResult"); }

	int			m_nState;
	BYTE		m_Hash[16];
	CEmClient*	m_pClient;
	bool		m_bFound;
};

//////////////////////////////////////////////////////////////////////
// Send requested block
struct CTask_SendBlock : public CTask {
	CTask_SendBlock(BYTE Hash[16], CEmClient* pClient, DWORD dwStart, DWORD dwEnd);
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("SendBlock"); }

	int			m_nState;
	BYTE		m_Hash[16];
	CEmClient*	m_pClient;
	DWORD		m_dwStart;
	DWORD		m_dwEnd;
	DWORD		m_dwToGo;
	BYTE*		m_pFileData;
};

//////////////////////////////////////////////////////////////////////
// Send file status
struct CTask_SendFileStatus : public CTask {
	CTask_SendFileStatus(BYTE Hash[16], CEmClient* pClient);
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("SendFileStatus"); }

	int			m_nState;
	BYTE		m_Hash[16];
	CEmClient*	m_pClient;
	BYTE*		m_pFileStatus;
	USHORT		m_nStatusSize;
};

//////////////////////////////////////////////////////////////////////
// Send hashsets
struct CTask_SendHashsets : public CTask {
	CTask_SendHashsets(BYTE Hash[16], CEmClient* pClient);
	virtual bool Process();
	virtual LPCTSTR TaskName(){ return _T("SendHashsets"); }

	int			m_nState;
	BYTE		m_Hash[16];
	CEmClient*	m_pClient;
	HASH*		m_pFileHashes;
	USHORT		m_nHashCount;
};
