#include "stdafx.h"
#include "../Sockets/TasksSockets.h"
#include "../Database/TaskProcessorDB.h"
#include "../Files/TaskProcessorFiles.h"
#include "../../SharedFileList.h"
#include "../../BerkeleyDb/build_win32/db_cxx.h"

#include "XML.h"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
XML_PROCESS_FUNC(connect)
{
	g_stEngine.ConnectToServer(m_sAddr, m_ulPort);

	//PrepareResult();
	return true;
}
XML_RESULT_FUNC(connect)
{
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
XML_PROCESS_FUNC(disconnect)
{
	g_stEngine.DisconnectFromServer();

	//PrepareResult();
	return true;
}
XML_RESULT_FUNC(disconnect)
{
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
XML_PROCESS_FUNC(hello)
{
//	::MessageBox(NULL, _T("hello"), _T(""), MB_OK|MB_TOPMOST);

	SendBuf((LPCTSTR)PrepareResult()->xml);

	return true;
}
XML_RESULT_FUNC(hello)
{
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
XML_PROCESS_FUNC(quit)
{
//	::MessageBox(NULL, _T("quit"), _T(""), MB_OK|MB_TOPMOST);

	SendBuf((LPCTSTR)PrepareResult()->xml);

	g_stEngine.ShutDown();

	return true;
}
XML_RESULT_FUNC(quit)
{
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
XML_PROCESS_FUNC(get_logs)
{
	switch(m_nState)
	{
	case XML_GET_START:
		m_nState = XML_GET_READ;
		m_spDoc = PrepareResult();
		g_stEngine.DB.Push(this);
		return false;
	case XML_GET_READ:
		m_nState = XML_GET_SEND;
		// Get all records from logs
		try 
		{
			Dbc *dbcp;
			g_stEngine.DB.Logs.cursor(NULL, &dbcp, 0);
			Dbt key;
			Dbt data;
			while (dbcp->get(&key, &data, DB_NEXT) == 0) 
			{
				long lTime = *((long*)key.get_data());
				BYTE *pData = (BYTE*)data.get_data();
				BOOL bDebug = *((BOOL*)pData);
				LPCTSTR sLine = (LPCTSTR)(pData + sizeof(BOOL));
				XmlElement spElem = XmlCreateElement(m_spDoc, m_spDoc->documentElement, _T("log"));
				XmlSetAttribute(spElem, _T("time"), lTime);
				XmlSetAttribute(spElem, _T("debug"), bDebug);
				XmlSetAttribute(spElem, _T("text"), sLine);
			}
			dbcp->close();
		}
		catch (DbException &dbe) 
		{
			TRACE("Problems: %s.\n", dbe.what());
		}
		catch(...)
		{
			TRACE("Problems read log from database.\n");
		}
		g_stEngine.Sockets.Push(this);
		return false;
	case XML_GET_SEND:
		SendBuf((LPCTSTR)m_spDoc->xml);
		return true;
	}
	return true;
}
XML_RESULT_FUNC(get_logs)
{
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
XML_PROCESS_FUNC(get_shared)
{
	switch(m_nState)
	{
	case XML_GET_START:
		m_nState = XML_GET_READ;
		m_spDoc = PrepareResult();
		g_stEngine.DB.Push(this);
		return false;
	case XML_GET_READ:
		m_nState = XML_GET_SEND;
		// Get all shared files
		try 
		{
			for(POSITION pos = g_stEngine.Files.SharedFiles.m_mapSharedFiles.GetStartPosition(); pos != NULL; )
			{
				CCKey		bufKey;
				CKnownFile*	pKnownFile = NULL;
				g_stEngine.Files.SharedFiles.m_mapSharedFiles.GetNextAssoc(pos, bufKey, pKnownFile);
				if(pKnownFile && !pKnownFile->IsPartFile())
				{
					XmlElement spElem = XmlCreateElement(m_spDoc, m_spDoc->documentElement, _T("file"));
					XmlSetAttribute(spElem, _T("hash"), (LPCTSTR)HashToString(pKnownFile->GetFileHash()));
					XmlSetAttribute(spElem, _T("name"), (LPCTSTR)pKnownFile->GetFileName());
					XmlSetAttribute(spElem, _T("size"), pKnownFile->GetFileSize());
					XmlSetAttribute(spElem, _T("type"), pKnownFile->GetFileType());
					XmlSetAttribute(spElem, _T("link"), (LPCTSTR)pKnownFile->CreateED2kLink());
				}
			}
		}
		catch(...)
		{
			TRACE("Problems read shared files.\n");
		}
		g_stEngine.Sockets.Push(this);
		return false;
	case XML_GET_SEND:
		SendBuf((LPCTSTR)m_spDoc->xml);
		return true;
	}
	return true;
}
XML_RESULT_FUNC(get_shared)
{
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
